import os
import sys
import networkx as nx
from multiprocessing import Pool
indir=sys.argv[1]
n=int(sys.argv[2])
queries=[]
for root, dirs, filenames in os.walk(indir):
	for f in filenames:
		if not ".count" in f and 'mod' not in f: 
			queries.append(os.path.join(root, f))

def convertv(fn):
    f=open(fn,'r')
    fout=open(fn+'O1','w')
    for line in f.readlines():
        line=line.split(' ')
        fout.write(str(int(line[0])+1)+'\t'+str(int(line[1])+1)+'\n')
    f.close()
    fout.close()
    return 1    
def convert(fn):
    G=nx.read_edgelist(fn)
    G.remove_edges_from(G.selfloop_edges())
    G.remove_nodes_from(nx.isolates(G))
    G=nx.relabel_nodes(G,{G.nodes()[i]:i+1 for i in range(nx.number_of_nodes(G))})
    nx.write_edgelist(G,fn+'mod',delimiter='\t',data=False)
    return 1     

sdir=os.getcwd()+'/'

def count(name):
    convert(sdir+name)
    f=open(name+'nearg','w')
    f.write(sdir+name+'mod\n')
    f.write(sdir+name+'.countsNE\n')
    f.write('node_egos\n')
    f.write('1\n')
    f.close()
    os.system('Rscript egonet_subgraphs.R '+name+'nearg')
    os.system('rm '+name+'nearg')
    os.system('rm '+sdir+name+'mod')
    

if __name__ == '__main__':
        p = Pool(n)
        c=p.map(count, queries)
